@echo off
setlocal enableextensions enabledelayedexpansion

cd "%~dp0"
@RD /S /Q "tempFolder" >NUL 2>NUL

md tempFolder >NUL 2>NUL
md FIXED_CIAs >NUL 2>NUL

set /a _count=0
for %%A in (%*) DO (
    call :fixAGBCIA "%%~fA"
    set /a _count+=1
    cls
    echo.
    echo.
    echo.
    echo    Status: !_count! CIAS fixed
)

RD /S /Q "tempFolder"
echo    Done^^!^^!
echo.
echo.
pause
exit /b

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:getFilesize
set filesize=%~z1
exit /b
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:fixAGBCIA
:: dump the CIA's contents
progfiles\ctrtool.exe --contents tempFolder\dump "%~f1" >NUL 2>NUL
progfiles\3dstool.exe -xtf cxi tempFolder\dump.0000.00000000 --header tempFolder\ncchheader.bin --exh tempFolder\exheader.bin --exefs tempFolder\exefs.bin --romfs tempFolder\romfs.bin >NUL 2>NUL
progfiles\3dstool.exe -xutf exefs tempFolder\exefs.bin --exefs-dir tempFolder\exefs --header "tempFolder\exefsheader.bin" >NUL 2>NUL

::get code.bin and dump only the rom plus beginning of the footer
call :getFilesize tempFolder\exefs\code.bin
set /A filesize -= 832
progfiles\head.exe -c %filesize% tempFolder\exefs\code.bin > tempFolder\exefs\tempBEGIN.bin

::dump the ending of the footer
progfiles\tail.exe -c 60 tempFolder\exefs\code.bin > tempFolder\exefs\tempEND.bin

::assemble a new code.bin
copy /b tempFolder\exefs\tempBEGIN.bin + progfiles\GFX_Fix.bin + tempFolder\exefs\tempEND.bin tempFolder\exefs\code.bin >NUL 2>NUL

del tempFolder\exefs\tempBEGIN.bin
del tempFolder\exefs\tempEND.bin

:: rebuild the CIA
progfiles\3dstool.exe -ctf exefs tempFolder\newExefs.bin --exefs-dir tempFolder\exefs --header tempFolder\exefsheader.bin >NUL 2>NUL
progfiles\3dstool.exe -ctf cxi tempFolder\fixed.cxi --header tempFolder\ncchheader.bin --exh tempFolder\exheader.bin --exefs tempFolder\newexefs.bin --romfs tempFolder\romfs.bin >NUL 2>NUL
progfiles\makerom.exe -f cia -content tempFolder\fixed.cxi:0:0 -o "FIXED_CIAS\%~n1_Fixed.cia" >NUL 2>NUL

exit /b
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
